<?php
// +----------------------------------------------------------------------
// | ThinkPHP [ WE CAN DO IT JUST THINK IT ]
// +----------------------------------------------------------------------
// | Copyright (c) 2006-2014 http://thinkphp.cn All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: luofei614 <weibo.com/luofei614>
// +----------------------------------------------------------------------

/**
 * SAE模式慣例配置文件
 * 該文件請不要修改，如果要覆蓋慣例配置的值，可在應用配置文件中設定和慣例不符的配置項
 * 配置名稱大小寫任意，系統會統一轉換成小寫
 * 所有配置參數都可以在生效前動態改變
 */
defined('THINK_PATH') or exit();
$st =   new SaeStorage();
return array(
    //SAE下固定mysql配置
    'DB_TYPE'           =>  'mysql',     // 數據庫類型
    'DB_DEPLOY_TYPE'    =>  1,
    'DB_RW_SEPARATE'    =>  true,
    'DB_HOST'           =>  SAE_MYSQL_HOST_M.','.SAE_MYSQL_HOST_S, // 服務器地址
    'DB_NAME'           =>  SAE_MYSQL_DB,        // 數據庫名
    'DB_USER'           =>  SAE_MYSQL_USER,    // 用戶名
    'DB_PWD'            =>  SAE_MYSQL_PASS,         // 密碼
    'DB_PORT'           =>  SAE_MYSQL_PORT,        // 端口
    //更改模板替換變量，讓普通能在所有平台下顯示
    'TMPL_PARSE_STRING' =>  array(
        // __PUBLIC__/upload  -->  /Public/upload -->http://appname-public.stor.sinaapp.com/upload
        '/Public/upload'    =>  $st->getUrl('public','upload')
    ),
    'LOG_TYPE'          =>  'Sae',
    'DATA_CACHE_TYPE'   =>  'Memcachesae',
    'CHECK_APP_DIR'     =>  false,
    'FILE_UPLOAD_TYPE'  =>  'Sae',
);
